// TODO:是否要把所有格式转换的部分都放到这个extension中？

import 'dart:convert';
import 'dart:ffi';

extension MapExtension on Map {
  bool boolValue(String key) {
    if (!containsKey(key)) {
      return false;
    } else if (this[key] is int) {
      return this[key] == 0 ? false : true;
    } else if (this[key] is String) {
      return this[key].toString().length == 0 ? false : true;
    } else {
      return false;
    }
  }

  int intValue(String key, [int defValue = -1]) {
    if (!containsKey(key)) {
      return defValue;
    } else if (this[key] is int) {
      return this[key];
    } else if (this[key] is String) {
      return  int.parse(this[key]);
    } else {
      return defValue;
    }
  }

  List<String> listStringValue(String key, [List<String> defValue = const <String>[]]) {
    if (!containsKey(key)) {
      return defValue;
    } else if (this[key] is List) {
      return this[key];
    } else if (this[key] is String) {
      String valueStr = this[key];
      try {
        var value = json.decode(valueStr);
        if(value is List<String>) {
          return value;
        }
      } catch(e) {
        return defValue;
      }
      return  defValue;
    } else {
      return defValue;
    }
  }
}
